
USE SVH_REPORT_DB
GO

/*
|| Autor: Dani Bieto 
|| Fecha: 2022.03.22
|| Proyecto: JUNO
|| Proceso: Generación de tabla datamart de Contratos Alquileres
*/


/*
|| MODELO JUNO
|| Granularidad: SOCIEDAD + UR + UA
||	Perimetro:	  Todos los alquileres de Kutxa Bank
*/


--=========================================================================================================================================
--														                          TABLAS TEMPORALES                                                        
--=========================================================================================================================================

/*
|| Autor: Dani Bieto
|| Fecha: 2022.03.22
|| Proceso: Tablas temporales que van a contener la data a cierre de mes, que se obtienen de las tablas Historicas
*/

DECLARE @ANYOMES VARCHAR(6);	
DECLARE @ANYOMES_BARRA VARCHAR(7);	
DECLARE @DIA DATE;
DECLARE @DIA_MES_ANTERIOR VARCHAR(10); 
DECLARE @PERIODO INT;
DECLARE @ANYOMES_BORRADO VARCHAR(6);

SET @ANYOMES = CONVERT(VARCHAR(6),DATEADD(dd,-(DAY(GETDATE())),GETDATE()),112);
SET @DIA = GETDATE()
SET @ANYOMES_BARRA = (SELECT CONCAT(SUBSTRING(@ANYOMES,1,4),'/',SUBSTRING(@ANYOMES,5,2)))
SET @DIA_MES_ANTERIOR = CONVERT(VARCHAR(10),DATEADD(DD,-(DAY(GETDATE())),GETDATE()),121)
SET @PERIODO = (SELECT MAX(PERIODO) FROM [JUNO].[INF_ARRENDAMIENTO] WHERE PERIODO != @ANYOMES);
SET @ANYOMES_BORRADO = CONVERT(VARCHAR(6),REPLACE(EOMONTH(DATEADD(month, -24, GETDATE())),'-',''));

--==========================================================================--
--						Temporal Sociedades									--
--==========================================================================--

DROP TABLE IF EXISTS #TMP_SOCIEDADES

SELECT CAMPO, 
		 VALOR AS SOCIEDAD
  INTO #TMP_SOCIEDADES
  FROM [JUNO].[TMP_PARAMETRICA]
WHERE INFORME = 'SOCIEDAD'
  AND CONCEPTO IN('KUTXABANK. PERIMETRO BANCOS', 'KUTXABANK. PERIMETRO INMOBILIARIA')
  AND FLAG = 1


-----------------------------------
-- Mapeo Descripción Tipo Activo --
-----------------------------------

DROP TABLE IF EXISTS #TMP_TIPO_INMUEBLE

SELECT CONCEPTO AS TIPO_INMUEBLE,
       VALOR
  INTO #TMP_TIPO_INMUEBLE
  FROM JUNO.TMP_PARAMETRICA
 WHERE CAMPO = 'TIPO_INMUEBLE'
   AND FLAG = 1

--==========================================================================--
--						RENTA CONTRATOS     								--
--==========================================================================--

DROP TABLE IF EXISTS #TMP_RENTA_CONTRATOS

SELECT CONT.SOCIEDAD,
       CONTRATO,
       SUM(IMPORTE_BRUTO_MES*12) AS IMPORTE_BRUTO_ANUAL,
		 SUM(IMPORTE_NETO_MES) IMPORTE_NETO_MES
INTO #TMP_RENTA_CONTRATOS       
FROM  SVH_CORP_DB.DBO.RENTA_CONTRATOS CONT
INNER JOIN #TMP_SOCIEDADES SOCIEDADES
  ON  CONT.SOCIEDAD = SOCIEDADES.SOCIEDAD
WHERE CLASE_CONDICION IN ('100', '101', '103', '126','251', '252', '255') 
AND @DIA_MES_ANTERIOR BETWEEN FECHA_INI_VALIDEZ_CONDICION AND FECHA_FIN_VALIDEZ_CONDICION
AND DIA = @DIA_MES_ANTERIOR
GROUP BY CONT.SOCIEDAD, CONTRATO


--==========================================================================--
--						FI PARTIDAS		    								--
--==========================================================================--

DROP TABLE IF EXISTS #TMP_FI_PARTIDAS

SELECT SOCIEDAD,
       UNIDAD_REGISTRAL,
	   ADJ178_FIANZA_RECIBIDA,
	   ADJ179_CANTIDADES_RECIBIDAS,
	   ADJ466_COSTES_IMPUTABLES_INQUILINOS,
	   ADJ180_ALQUILERES_VENCIDOS_PENDIENTES
INTO #TMP_FI_PARTIDAS
FROM SVH_REPORT_DB.JUNO.MAESTRO_FI_PARTIDAS_UR
WHERE PERIODO = @ANYOMES

--=================================================================================================--
--   Contratos de Garantía - Necesarios para saber que activos tienen fianza y el importe          --
--=================================================================================================--

DROP TABLE IF EXISTS #TMP_CONTRATOS_GARANTIA

	SELECT UR.SOCIEDAD,
		   UR.UNIDAD_REGISTRAL,
		   NUMERO_CONTRATO ,
		   NUMERO_CONTRATO_TXT,
		   CONT.CONTRATO_GARANTIA,
		   CONT.CONTRATO,
		   CONT.ANYO_MES_NATURAL,
		   SUM(IMPORTE) AS IMPORTE
	INTO #TMP_CONTRATOS_GARANTIA
	FROM SVH_CORP_DB.DBO.FI_PARTIDAS_UR UR
	LEFT JOIN SVH_CORP_DB.DBO.CONTRATOS CONT
	ON UR.SOCIEDAD = CONT.SOCIEDAD
	AND UR.NUMERO_CONTRATO_TXT = CONT.CONTRATO_GARANTIA
	WHERE (CUENTA_MAYOR LIKE '0000180%' OR CUENTA_MAYOR LIKE '0000181%')
	AND UR.SOCIEDAD IN (200,201,210,220,230,240,250,260,270,280)
	AND NUMERO_CONTRATO IS NOT NULL
	AND CONT.ANYO_MES_NATURAL = @ANYOMES_BARRA
	AND CONT.UNIDAD_ECONOMICA IS NOT NULL
	GROUP BY UR.SOCIEDAD,
		   UR.UNIDAD_REGISTRAL,
		   NUMERO_CONTRATO ,
		   NUMERO_CONTRATO_TXT,
		   CONT.CONTRATO_GARANTIA,
		   CONT.CONTRATO,
		   CONT.ANYO_MES_NATURAL

--=========================================================================================================================================
--										Tabla Temporal con los datos del Histórico (Repositorio) Mes Anterior ARRENDAMIENTO
--=========================================================================================================================================

DROP TABLE IF EXISTS #TMP_INF_ARRENDAMIENTO_PERIODO_ANT

SELECT PERIODO 
	 , ADJ317
     , ADJ365
	 , ADJ466
INTO #TMP_INF_ARRENDAMIENTO_PERIODO_ANT
  FROM [JUNO].[INF_ARRENDAMIENTO] ADJ
 WHERE PERIODO = @PERIODO


 --=========================================================================--
 --						UNION TEMPORALES                                    --
 --=========================================================================--

 DROP TABLE IF EXISTS #TMP_ARRENDAMIENTO

 SELECT UA.SOCIEDAD,
        UA.UNIDAD_REGISTRAL,
		UA.DESC_UNIDAD_REGISTRAL,
		UA.UNIDAD_ECONOMICA,
		UA.DESC_UNIDAD_ECONOMICA,
		UA.DESC_OBJETO_ALQUILER,
		UA.FECHA_ALQUILER_CONTRATO,
		UA.FECHA_FIN_VIGENCIA_CONTRATO,
		UA.OBJETO_ALQUILER,
		UA.CONTRATO,
        UA.FECHA_HASTA_CONTRATO, 
        UA.CLASE_CONTRATO, 
        UA.DESC_CLASE_CONTRATO,
		UA.ESTADO_DOCUMENTO_WF,
        UA.FECHA_ALTA_CONTRATO,
        UA.FECHA_BAJA_CONTRATO_ALQUILER ,
		UA.FECHA_INICIO_RELACION,
		UA.FECHA_FIN_RELACION,
        UA.RESCISION_ESTIMADA , 
        UA.MOTIVO_RESCISION , 
        UA.DESC_MOTIVO_RESCISION , 
        UA.RESCISION, 
        UA.TIPO_INMUEBLE , 
        UA.DESC_TIPO_INMUEBLE,
        UA.CLASE_USO_UA,
        UA.DESC_CLASE_USO_UA,
		UA.ANYO_MES_NATURAL,
		FI_PARTIDAS.ADJ178_FIANZA_RECIBIDA,
		FI_PARTIDAS.ADJ179_CANTIDADES_RECIBIDAS,
		FI_PARTIDAS.ADJ466_COSTES_IMPUTABLES_INQUILINOS,
		FI_PARTIDAS.ADJ180_ALQUILERES_VENCIDOS_PENDIENTES,
		TIPO_INMUEBLE.VALOR AS TIPO,
		RC.IMPORTE_BRUTO_ANUAL,
		RC.IMPORTE_NETO_MES,
		MAPEO.UNIDAD_REGISTRAL_KB,
		MAPEO.SOCIEDAD_KB
  INTO #TMP_ARRENDAMIENTO
   FROM SVH_CORP_DB.DBO.RELACIONES_CONTRATO_UA UA
   INNER JOIN #TMP_SOCIEDADES SOCIEDADES
	  ON UA.SOCIEDAD = SOCIEDADES.SOCIEDAD
 	LEFT JOIN #TMP_FI_PARTIDAS FI_PARTIDAS
	  ON UA.SOCIEDAD = FI_PARTIDAS.SOCIEDAD
	  AND UA.UNIDAD_REGISTRAL = FI_PARTIDAS.UNIDAD_REGISTRAL
	LEFT JOIN #TMP_TIPO_INMUEBLE TIPO_INMUEBLE
	  ON UA.TIPO_INMUEBLE = TIPO_INMUEBLE.TIPO_INMUEBLE	 
	LEFT JOIN #TMP_RENTA_CONTRATOS RC 
	  ON UA.SOCIEDAD = RC.SOCIEDAD  
	 AND UA.CONTRATO = RC.CONTRATO
	LEFT JOIN SVH_REPORT_DB.JUNO.TMP_MAPEO_URS MAPEO
	  ON UA.SOCIEDAD = MAPEO.SOCIEDAD
     AND UA.UNIDAD_REGISTRAL = MAPEO.UNIDAD_REGISTRAL

DROP TABLE IF EXISTS #TMP_ARRENDAMIENTO_P2

SELECT DISTINCT UA.*,
				CONT.INTERLOC_COMERC,
				CONT.DESC_INTERLOC_COMERC,
				CLI.NIF,
				CLI.NOMBRE_1,
				ARR_ANT.ADJ466,
				DATOS_UA.SUPERFICIE_ALQUILABLE,
				DATOS_UA.SUPERFICIE_TASACION_CONSTRUIDA,
				DATOS_UA.SUPERFICIE_REGISTRAL_CONSTRUIDA,
				DATOS_UA.SUPERFICIE_TASACION_UTIL,
				DATOS_UA.SUPERFICIE_REGISTRAL_UTIL
INTO #TMP_ARRENDAMIENTO_P2
    FROM #TMP_ARRENDAMIENTO UA
 	LEFT JOIN SVH_CORP_DB.DBO.CONTRATOS CONT
	  ON UA.SOCIEDAD         = CONT.SOCIEDAD
	 AND UA.CONTRATO         = CONT.CONTRATO
	 AND UA.ANYO_MES_NATURAL = CONT.ANYO_MES_NATURAL
	 LEFT JOIN SVH_CORP_DB.DBO.INTERLOCUTORES_CONTRATO INTER
	    ON CAST(CAST(CONT.INTERLOC_COMERC AS NUMERIC) AS VARCHAR) = CAST(INTER.INTERLOCUTOR_COMERCIAL AS VARCHAR)
     LEFT JOIN SVH_CORP_DB.DBO.CLIENTES CLI
	    ON RIGHT('0000000000' + CAST(CAST(INTER.NUM_DEUDOR AS NUMERIC(10)) AS VARCHAR(10)),10) = CLI.NUM_DEUDOR
    LEFT JOIN #TMP_INF_ARRENDAMIENTO_PERIODO_ANT ARR_ANT 
	  ON UA.UNIDAD_REGISTRAL_KB = ARR_ANT.ADJ317
     AND CAST(CAST(CONT.INTERLOC_COMERC AS NUMERIC) AS VARCHAR(15)) = ARR_ANT.ADJ365
	LEFT JOIN SVH_CORP_DB.DBO.DATOS_GENERALES_UA DATOS_UA
	  ON UA.SOCIEDAD																   = DATOS_UA.SOCIEDAD
	 AND UA.UNIDAD_REGISTRAL														   = DATOS_UA.UNIDAD_REGISTRAL
	 AND UA.UNIDAD_ECONOMICA														   = DATOS_UA.UNIDAD_ECONOMICA
	 AND UA.OBJETO_ALQUILER                                                            = DATOS_UA.OBJETO_ALQUILER
	 AND UA.CONTRATO = DATOS_UA.CONTRATO
	 AND CONCAT(SUBSTRING(UA.ANYO_MES_NATURAL,1,4),SUBSTRING(UA.ANYO_MES_NATURAL,6,2)) = DATOS_UA.ANYO_NATURAL_MES


DROP TABLE IF EXISTS #TMP_ARRENDAMIENTO_P3

	SELECT @ANYOMES																									AS PERIODO,
	       UA.SOCIEDAD																								AS SOCIEDAD,
	       UA.UNIDAD_REGISTRAL																						AS UNIDAD_REGISTRAL,
		   CASE 
				WHEN ISNULL(FUSION.PROMO_INI, '') != '' THEN FUSION.PROMO_INI
				WHEN UR.PROMOCION_COMERCIAL IS NOT NULL THEN CAST(UR.PROMOCION_COMERCIAL AS VARCHAR)
				ELSE CAST(UR.PROMOCION_CONJUNTA AS VARCHAR) 
		   END																										AS PROYECTO_IDENTIFICACION_PROYECTO,
		   UA.TIPO            																						AS TIPO,
		   CAST(CAST(UA.INTERLOC_COMERC AS NUMERIC) AS VARCHAR(15))												    AS INTERLOCUTOR_COMERCIAL,
		   cast(cast(UA.UNIDAD_REGISTRAL as numeric) as varchar)													AS ADJ317_CODIGO_ACTIVO,
	       '' AS CLAVE1,
	       '' AS CLAVE2,
	       '' AS CLAVE3, 
		   '' AS CLAVE4,
		   UA.NIF																									AS ADJ365_ID_ARRENDATARIO,
		   UA.NOMBRE_1																								AS ADJ464_NOMBRE_ARRENDATARIO,
		   --UA.DESC_INTERLOC_COMERC																					AS ADJ464_NOMBRE_ARRENDATARIO, -- Duda, en la logica hay 4 campos
	       UA.DESC_OBJETO_ALQUILER																					AS ADJ173_ID_UNIDAD_ALQUILADA,
		   UA.FECHA_ALQUILER_CONTRATO																				AS ADJ174_FECHA_INICIO_CONTRATO_ALQUILER,
		   UA.FECHA_FIN_VIGENCIA_CONTRATO																			AS ADJ175_FECHA_VENCIMIENTO_CONTRATO_ALQUILER,
		   'N'																										AS ADJ176_OPCION_RENOVACION,
		   CASE WHEN UA.CLASE_CONTRATO = '2' THEN 'S'  ELSE 'N' END													AS ADJ177_OPCION_COMPRA,
		   UA.IMPORTE_BRUTO_ANUAL																					AS ADJ465_IMPORTE_BRUTO_ANUAL,
	       UA.OBJETO_ALQUILER,
	       UA.DESC_UNIDAD_REGISTRAL, 
	       UA.UNIDAD_ECONOMICA, 
	       UA.FECHA_INICIO_RELACION ,
	       UA.FECHA_FIN_RELACION ,
  	       CASE WHEN (UA.RESCISION IS NULL OR 
  		             (UA.RESCISION IS NOT NULL AND 
  					  UA.ESTADO_DOCUMENTO_WF = '' AND 
  					  UA.ESTADO_DOCUMENTO_WF = 'NRES' AND 
  					  UA.ESTADO_DOCUMENTO_WF = 'PRES'))
  	             AND UA.CLASE_CONTRATO IN  (1,2,3,6,11,12,15,16,18,19,20,21,27,28,29,30,31,32,33,34,35)
  	             AND @DIA >= UA.FECHA_INICIO_RELACION 
  	             AND @DIA < UA.FECHA_FIN_RELACION     
                THEN 'ALQUILADO'
  	            ELSE 'NO ALQUILADO'
	       END AS ESTADO_ALQUILER,
	       UA.DESC_UNIDAD_ECONOMICA,
	       UA.CONTRATO,
	       UA.FECHA_HASTA_CONTRATO, 
	       UA.CLASE_CONTRATO, 
	       UA.DESC_CLASE_CONTRATO,
	       UA.FECHA_ALTA_CONTRATO,
	       UA.FECHA_BAJA_CONTRATO_ALQUILER ,
	       UA.RESCISION_ESTIMADA , 
	       UA.MOTIVO_RESCISION , 
	       UA.DESC_MOTIVO_RESCISION , 
	       UA.RESCISION, 
	       UA.TIPO_INMUEBLE , 
	       UA.DESC_TIPO_INMUEBLE,
	       UA.CLASE_USO_UA,
	       UA.DESC_CLASE_USO_UA,
	       UA.ESTADO_DOCUMENTO_WF,
	       CASE WHEN UA.CLASE_USO_UA IN ('0001','0003','0053') THEN 'Residencial'	
                WHEN UA.CLASE_USO_UA IN ('0013') THEN 'Oficinas'
                WHEN UA.CLASE_USO_UA IN ('0002','0012','0070') THEN 'Locales'
                WHEN UA.CLASE_USO_UA IN ('0023') THEN 'Industrial'
                WHEN UA.CLASE_USO_UA IN ('0025') THEN 'Hotel'
                WHEN UA.CLASE_USO_UA IN ('0005') THEN 'Parking'
                WHEN UA.CLASE_USO_UA IN ('0004') THEN 'Trastero'
                WHEN UA.CLASE_USO_UA NOT IN ('0001','0003','0053','0013','0002','0012','0070','0023','0025','0005','0004') THEN 'Otros'
          END AS CLASE_USO_AGRUPADO,
		  CASE WHEN UA.CLASE_USO_UA IN ('0001','0003','0053') 	THEN 1 ELSE 0 END AS UAS_RESIDENCIAL,
		  CASE WHEN UA.CLASE_USO_UA IN ('0013') 				THEN 1 ELSE 0 END AS UAS_OFICINAS,
		  CASE WHEN UA.CLASE_USO_UA IN ('0002','0012','0070')  THEN 1 ELSE 0 END AS UAS_LOCALES ,
		  CASE WHEN UA.CLASE_USO_UA IN ('0023')  				THEN 1 ELSE 0 END AS UAS_INDUSTRIAL,
		  CASE WHEN UA.CLASE_USO_UA IN ('0025')  				THEN 1 ELSE 0 END AS UAS_HOTEL,
		  CASE WHEN UA.CLASE_USO_UA IN ('0005')  				THEN 1 ELSE 0 END AS UAS_PARKING,
		  CASE WHEN UA.CLASE_USO_UA IN ('0004') 				THEN 1 ELSE 0 END AS UAS_TRASTERO,
		  CASE WHEN UA.CLASE_USO_UA NOT IN ('0001','0003','0053','0013','0002','0012','0070','0023','0025','0005','0004') THEN 1 ELSE 0 END AS UAS_OTROS,
		  CASE WHEN ISNULL(CAST(UA.SUPERFICIE_ALQUILABLE AS VARCHAR),'') <> ''           AND CAST(UA.SUPERFICIE_ALQUILABLE AS VARCHAR) <> '0.0000' THEN UA.SUPERFICIE_ALQUILABLE
			   WHEN ISNULL(CAST(UA.SUPERFICIE_TASACION_CONSTRUIDA AS VARCHAR),'') <> ''  AND CAST(UA.SUPERFICIE_TASACION_CONSTRUIDA AS VARCHAR) <> '0.000' THEN UA.SUPERFICIE_TASACION_CONSTRUIDA
			   WHEN ISNULL(CAST(UA.SUPERFICIE_REGISTRAL_CONSTRUIDA AS VARCHAR),'') <> '' AND CAST(UA.SUPERFICIE_REGISTRAL_CONSTRUIDA AS VARCHAR) <> '0.000' THEN UA.SUPERFICIE_REGISTRAL_CONSTRUIDA
		       WHEN ISNULL(CAST(UA.SUPERFICIE_TASACION_UTIL AS VARCHAR),'') <> ''        AND CAST(UA.SUPERFICIE_TASACION_UTIL AS VARCHAR) <> '0.000' THEN UA.SUPERFICIE_TASACION_UTIL
			   WHEN ISNULL(CAST(UA.SUPERFICIE_REGISTRAL_UTIL AS VARCHAR),'') <> ''       AND CAST(UA.SUPERFICIE_REGISTRAL_UTIL AS VARCHAR) <> '0.000'  THEN UA.SUPERFICIE_REGISTRAL_UTIL
			   ELSE '0.0000'
		  END AS SUPERFICIE_REAL_ALQUILADA,
		  ISNULL(UA.ADJ178_FIANZA_RECIBIDA,0) AS ADJ178_FIANZA_RECIBIDA,															-- Fi Partidas Mes actual	
		  0 AS ADJ179_CANTIDADES_RECIBIDAS,													-- Fi Partidas Mes actual
		  ISNULL(UA.ADJ466,0) + ISNULL(UA.ADJ466_COSTES_IMPUTABLES_INQUILINOS,0)	 AS ADJ466_COSTES_IMPUTABLES_INQUILINOS,    -- Historico Fi Partidas + Mes actual
		  ISNULL(UA.ADJ180_ALQUILERES_VENCIDOS_PENDIENTES,0) AS ADJ180_ALQUILERES_VENCIDOS_PENDIENTES,								-- Fi Partidas Mes actual
		  CASE WHEN FUSION.UR_ORIGEN_INI != '' AND FUSION.UR_ORIGEN_INI != '0' THEN FUSION.UR_ORIGEN_INI 
		       ELSE CAST(UA.UNIDAD_REGISTRAL AS VARCHAR) 
	      END USR004_CODIGO_ACTIVO,
			UA.IMPORTE_NETO_MES
	INTO #TMP_ARRENDAMIENTO_P3
	FROM #TMP_ARRENDAMIENTO_P2 UA
	LEFT JOIN SVH_CORP_DB.DBO.DATOS_FUSION FUSION 
	  ON  UA.SOCIEDAD         = FUSION.SOCIEDAD 
	 AND UA.UNIDAD_REGISTRAL  = FUSION.UNIDAD_REGISTRAL
	LEFT JOIN SVH_REPORT_DB.JUNO.TMP_UR_MAESTRO_HIST UR
	  ON UA.SOCIEDAD         = UR.SOCIEDAD
	 AND UA.UNIDAD_REGISTRAL = UR.UNIDAD_REGISTRAL
	WHERE UA.ANYO_MES_NATURAL = @ANYOMES_BARRA
	  AND UA.UNIDAD_REGISTRAL != 0    


--================================================================--
--=   FIANZAS RECIBIDAS - Se marcan las UA con fianza recibida    --
--================================================================--

DROP TABLE IF EXISTS #TMP_FIANZA_RECIBIDA

SELECT GARANTIAS.NUMERO_CONTRATO,
       GARANTIAS.CONTRATO,
	   GARANTIAS.IMPORTE,  
	   MAESTRO.PERIODO, 
	   MAESTRO.UNIDAD_REGISTRAL, 
	   MAESTRO.ESTADO_ALQUILER,
	   MAESTRO.UNIDAD_ECONOMICA,
	   MAESTRO.DESC_UNIDAD_ECONOMICA,
	   MAESTRO.CLASE_USO_UA,
	   MAESTRO.ADJ173_ID_UNIDAD_ALQUILADA,
	   CONT.UNIDAD_REGISTRAL AS UNIDAD_REGISTRAL_REFERENCIA,
	   CASE WHEN MAESTRO.ESTADO_ALQUILER = 'ALQUILADO' AND GARANTIAS.IMPORTE <> 0.0 THEN 'X' 
	        ELSE '' 
       END AS IND_FIANZA_RECIBIDA
  INTO #TMP_FIANZA_RECIBIDA
  FROM #TMP_CONTRATOS_GARANTIA GARANTIAS
      LEFT JOIN #TMP_ARRENDAMIENTO_P3 MAESTRO
	  ON GARANTIAS.CONTRATO = MAESTRO.CONTRATO
	  AND SUBSTRING(GARANTIAS.ANYO_MES_NATURAL,1,4) = SUBSTRING(MAESTRO.PERIODO,1,4)
	  AND SUBSTRING(GARANTIAS.ANYO_MES_NATURAL,6,2) = SUBSTRING(MAESTRO.PERIODO,5,2)
	  LEFT JOIN SVH_CORP_DB.DBO.CONTRATOS CONT
	  ON GARANTIAS.CONTRATO = CONT.CONTRATO
	  AND GARANTIAS.ANYO_MES_NATURAL = CONT.ANYO_MES_NATURAL
	 ORDER BY NUMERO_CONTRATO, UNIDAD_REGISTRAL, UNIDAD_ECONOMICA, CLASE_USO_UA

-- =========================== --	 
-- CONTAJE DE URS POR CONTRATO --
-- =========================== --

	DROP TABLE IF EXISTS #TMP_CONTADORES


	SELECT COUNT( *) AS CONT, CONTRATO,  UNIDAD_REGISTRAL, UNIDAD_REGISTRAL_REFERENCIA
	INTO  #TMP_CONTADORES
	FROM #TMP_FIANZA_RECIBIDA
	GROUP BY  CONTRATO, UNIDAD_REGISTRAL, UNIDAD_REGISTRAL_REFERENCIA
	ORDER BY CONTRATO,  UNIDAD_REGISTRAL,UNIDAD_REGISTRAL_REFERENCIA

--================================================================--
--=   FIANZAS RECIBIDAS FINAL - Se marcan las UA con fianza recibida    --
--================================================================--


	DROP TABLE IF EXISTS #TMP_FIANZA_FINAL

	  	 SELECT AUX.NUMERO_CONTRATO,
	        AUX.CONTRATO,
			AUX.IMPORTE,
			AUX.PERIODO,
			AUX.UNIDAD_REGISTRAL,
			AUX.ESTADO_ALQUILER,
			AUX.UNIDAD_ECONOMICA,
			AUX.CLASE_USO_UA,
			AUX.UNIDAD_REGISTRAL_REFERENCIA,
			AUX.ADJ173_ID_UNIDAD_ALQUILADA,
			AUX.IND_FIANZA_RECIBIDA,
			AUX.RN_IMPORTE_FIANZA,
			AUX.CONT,
			CASE WHEN AUX.CONT = 1 AND AUX.IND_FIANZA_RECIBIDA = 'X' AND UNIDAD_REGISTRAL = UNIDAD_REGISTRAL_REFERENCIA THEN AUX.IMPORTE
			     WHEN AUX.CONT > 1 AND RN_IMPORTE_FIANZA = 1 THEN AUX.IMPORTE
				 ELSE 0.0 
			END AS ADJ178_FIANZA_RECIBIDA
	 INTO #TMP_FIANZA_FINAL
	 FROM (SELECT FIANZA.NUMERO_CONTRATO,
				   FIANZA.CONTRATO,
				   FIANZA.IMPORTE,
				   FIANZA.PERIODO,
				   FIANZA.UNIDAD_REGISTRAL,
				   FIANZA.ESTADO_ALQUILER,
				   FIANZA.UNIDAD_ECONOMICA,
				   FIANZA.DESC_UNIDAD_ECONOMICA,
				   FIANZA.CLASE_USO_UA,
				   FIANZA.ADJ173_ID_UNIDAD_ALQUILADA,
				   FIANZA.UNIDAD_REGISTRAL_REFERENCIA,
				   FIANZA.IND_FIANZA_RECIBIDA,
				   CONT.CONT,
				   ROW_NUMBER() OVER(PARTITION BY    NUMERO_CONTRATO ORDER BY NUMERO_CONTRATO, CLASE_USO_UA, FIANZA.UNIDAD_REGISTRAL) RN_IMPORTE_FIANZA
			FROM #TMP_FIANZA_RECIBIDA FIANZA 
			LEFT JOIN #TMP_cONTADORES CONT 
			  ON FIANZA.CONTRATO = CONT.CONTRATO
			  AND FIANZA.UNIDAD_rEGISTRAL = CONT.UNIDAD_REGISTRAL
			  AND FIANZA.UNIDAD_REGISTRAL_rEFERENCIA = CONT.UNIDAD_REGISTRAL_rEFERENCIA
	) AUX
ORDER BY CONTRATO, UNIDAD_REGISTRAL, ADJ173_ID_UNIDAD_ALQUILADA	 

--==========================================================================--
--						MAESTRO UA CONTRATOS								--
--==========================================================================--

----=================================================----
---- PROCESO DE BORRADO DEL HISTORICO A 2 AÑOS VISTA ----
----=================================================----

	DELETE FROM  [JUNO].[MAESTRO_UA_CONTRATOS] WHERE PERIODO = @ANYOMES_BORRADO

----========================================================----
---- PROCESO DE BORRADO DEL DATAMART EN CASO DE REEJECUCIÓN ----
----========================================================----

	DELETE FROM  [JUNO].[MAESTRO_UA_CONTRATOS] WHERE PERIODO = @ANYOMES


----=======================----
---- INSERT TABLA DATAMART ----
----=======================----

	INSERT INTO  [JUNO].[MAESTRO_UA_CONTRATOS]
	SELECT  P3.PERIODO,
			P3.SOCIEDAD,
			P3.UNIDAD_REGISTRAL,
			P3.PROYECTO_IDENTIFICACION_PROYECTO,
			P3.TIPO,
			P3.INTERLOCUTOR_COMERCIAL,
			P3.ADJ317_CODIGO_ACTIVO,
			P3.CLAVE1,
			P3.CLAVE2,
			P3.CLAVE3,
			P3.CLAVE4,
			P3.ADJ365_ID_ARRENDATARIO,
			P3.ADJ464_NOMBRE_ARRENDATARIO,
			P3.ADJ173_ID_UNIDAD_ALQUILADA,
			P3.ADJ174_FECHA_INICIO_CONTRATO_ALQUILER,
			P3.ADJ175_FECHA_VENCIMIENTO_CONTRATO_ALQUILER,
			P3.ADJ176_OPCION_RENOVACION,
			P3.ADJ177_OPCION_COMPRA,
			P3.ADJ465_IMPORTE_BRUTO_ANUAL,
			P3.OBJETO_ALQUILER,
			P3.DESC_UNIDAD_REGISTRAL,
			P3.UNIDAD_ECONOMICA,
			P3.FECHA_INICIO_RELACION,
			P3.FECHA_FIN_RELACION,
			P3.ESTADO_ALQUILER,
			P3.DESC_UNIDAD_ECONOMICA,
			P3.CONTRATO,
			P3.FECHA_HASTA_CONTRATO,
			P3.CLASE_CONTRATO,
			P3.DESC_CLASE_CONTRATO,
			P3.FECHA_ALTA_CONTRATO,
			P3.FECHA_BAJA_CONTRATO_ALQUILER,
			P3.RESCISION_ESTIMADA,
			P3.MOTIVO_RESCISION,
			P3.DESC_MOTIVO_RESCISION,
			P3.RESCISION,
			P3.TIPO_INMUEBLE,
			P3.DESC_TIPO_INMUEBLE,
			P3.CLASE_USO_UA,
			P3.DESC_CLASE_USO_UA,
			P3.ESTADO_DOCUMENTO_WF,
			P3.CLASE_USO_AGRUPADO,
			P3.UAS_RESIDENCIAL,
			P3.UAS_OFICINAS,
			P3.UAS_LOCALES,
			P3.UAS_INDUSTRIAL,
			P3.UAS_HOTEL,
			P3.UAS_PARKING,
			P3.UAS_TRASTERO,
			P3.UAS_OTROS,
			P3.SUPERFICIE_REAL_ALQUILADA,
			ISNULL(FIANZA.ADJ178_FIANZA_RECIBIDA,0.0) AS ADJ178_FIANZA_RECIBIDA,
			P3.ADJ179_CANTIDADES_RECIBIDAS,
			P3.ADJ466_COSTES_IMPUTABLES_INQUILINOS,
			P3.ADJ180_ALQUILERES_VENCIDOS_PENDIENTES,
			P3.USR004_CODIGO_ACTIVO,
			P3.IMPORTE_NETO_MES,
	        ISNULL(FIANZA.IND_FIANZA_RECIBIDA,'') AS IND_FIANZA_RECIBIDA
	FROM #TMP_ARRENDAMIENTO_P3 P3
	LEFT JOIN #TMP_FIANZA_FINAL FIANZA
	ON P3.CONTRATO = FIANZA.CONTRATO
	AND P3.UNIDAD_REGISTRAL = FIANZA.UNIDAD_REGISTRAL
	AND P3.UNIDAD_ECONOMICA = FIANZA.UNIDAD_ECONOMICA
	AND P3.ADJ173_ID_UNIDAD_ALQUILADA = FIANZA.ADJ173_ID_UNIDAD_ALQUILADA

	----------------------------

